from asterisk.ami import AMIClient
from asterisk.ami import AutoReconnect
from dataEngine import AppConfig

API_CLIENT = None

def init_connection(event_listener):
    global API_CLIENT
    port = AppConfig.get("port")
    if API_CLIENT is None:
        API_CLIENT = AMIClient(address='127.0.0.1', port=port)

    def on_disconnect(client, error):
        if error is not None:
            print("Connection error: " + str(error))

    AutoReconnect(ami_client=API_CLIENT, delay=20, on_disconnect=on_disconnect)

    try:
        API_CLIENT.login(username='root', secret='wildix')
    except ConnectionRefusedError as e:
        print("Can't connect to AMI port {}".format(port))
        API_CLIENT = None
        AppConfig.set("stop", True)
        return
    # API_CLIENT.add_event_listener(event_listener, white_list=[
    #     "CEL",
    #     "MonitorStart",
    #     "MonitorStop",
    #     "UniqueIDMasquerade",
    #       "MusicOnHold",
    #       "BRIDGE_START",
    #       "BRIDGE_STOP",
    #       "REINIT_CHANNEL"
    # ])
    API_CLIENT.add_event_listener(event_listener, black_list=[
        "DeviceState",
        "Newchannel",
        "ChannelUpdate",
        "Newstate",
        "EventConnectedLine",
        "Bridge",
        "NewCallerid",
        "ExtensionStatus",
        "NewAccountCode",
        "HangupRequest",
        "SoftHangupRequest",
        "PeerStatus",
        "Cdr",
        "Hold",
        "QueueMemberStatus",
        "Dial",
        "Masquerade",
        "Rename",
        "BridgeAction",
        "Hangup",
        "EventFeature"  # {'Privilege': 'call,all', 'Device': '102', 'Feature': 'AWAY', 'State': 'false'}
    ])

def close_connection():
    if API_CLIENT:
        API_CLIENT.logoff()
