from dataEngine import Common

ChannelsList = {}
ChannelsListByName = {}

class ChanType:
    SIP = 1
    LOCAL = 2

class Channel(Common.PbxDataObject):
    def __init__(self, uid, lid, userID, email, userExtension, groupID, groupName, phone, name, chanType, chanName, context):
        # print("====Init channel " + str(uid))
        self.uid = uid
        self.lid = lid
        self.userId = userID
        self.email = email
        self.userExtension = userExtension
        self.groupId = groupID
        self.groupName = groupName
        self.phone = phone
        self.name = name
        self.company = None
        self.chanType = chanType
        self.chanName = chanName
        self.context = context

    def get_info(self):
        info_fields = ["userId","email","userExtension","groupId","groupName","phone","name"]
        return {attr:self.get(attr) for attr in info_fields if self.get(attr) is not None}

def add(chan):
    ChannelsList[chan.uid] = chan
    ChannelsListByName[chan.chanName] = chan

def get(uid):
    return ChannelsList.get(uid)

def get_by_name(chanName):
    return ChannelsListByName.get(chanName)

def uid_masquerade(uid1, uid2, lid):
    #print("\n >>> uid_masquerade dbg1 \n")
    chan1 = ChannelsList.get(uid1)
    chan2 = ChannelsList.get(uid2)
    if chan1 is None or chan2 is None:
        return
    chan1.set("uid", uid2)
    chan1.set("lid", lid)
    chan2.set("uid", uid1)
    chan2.set("lid", lid)
    ChannelsList[uid1] = chan2
    ChannelsList[uid2] = chan1
    ChannelsListByName[chan1.chanName] = chan2
    ChannelsListByName[chan2.chanName] = chan1

def end(uid):
    chan = ChannelsList.pop(uid, None)
    if chan:
        ChannelsListByName.pop(chan.chanName, None)

def print_currect_state():
    res = "ChannelsList:"
    for c in ChannelsList.keys():
        res += "\n\n{}".format(ChannelsList[c])
    print("===={}".format(res))
