import json
import os
import subprocess

# PBX
PBX_SERIAL = subprocess.getoutput("serial").lower()
PBX_KEY = subprocess.getoutput("sed '18q;d' /rw2/etc/sf2")

class PbxDataObject:
    def __getitem__(self, key):
        return getattr(self, key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def get(self, param):
        return getattr(self, param, None)

    def set(self, param, value):
        if value:
            setattr(self, param, value)

class PbxDataEncoder(json.JSONEncoder):
    def default(self, obj):
        if isinstance(obj, PbxDataObject):
            return {(key[1:] if key[0] == "_" else key):(val if val else None) for key,val in obj.__dict__.items()}
        return json.JSONEncoder.default(self, obj)
