import time
from scapy.all import rdpcap
from threading import Thread
from dataEngine import AppConfig, AmiMock

def process_pcap():
    scapy_cap = rdpcap(AppConfig.get("in_file"))
    timestamp = 0
    while not AmiMock.get_loogged_state():
        if PCAP_READER.exit:
            break
        time.sleep(0.5)
    for packet in scapy_cap:
        if PCAP_READER.exit:
            break
        srcport = int(packet.sprintf("{IP:{TCP:%TCP.sport%}}"))
        if srcport != 5039:
            continue
        payload = packet.sprintf("{IP:{TCP:%Raw.load%}}").replace("'", "").replace("\\r", "\r").replace("\\n", "\n").replace("\\\\", "\\")
        # print(packet.show())
        if payload.startswith("Event"):
            if timestamp > 0:
                sleep = packet.time - timestamp
                time.sleep(sleep)
            AmiMock.send(payload)
            timestamp = packet.time
    if not AppConfig.isStopped():
        AppConfig.set("stop", True)

def init():
    if AppConfig.isTest():
        PCAP_READER.thread.start()

def close():
    PCAP_READER.exit = True
    if PCAP_READER.thread.is_alive():
        PCAP_READER.thread.join()

class PcapReader():
    def __init__(self):
        self.thread = Thread(target=process_pcap)
        self.exit = False

PCAP_READER = PcapReader()
